<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_OperationTime ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_OperationTime extends AbstractStructArrayBase
{
    /**
     * The OperationTime
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_OperationTime[]
     */
    public $OperationTime;
    /**
     * Constructor method for ArrayOfJP_OperationTime
     * @uses ArrayOfJP_OperationTime::setOperationTime()
     * @param \StructType\JP_OperationTime[] $operationTime
     */
    public function __construct(array $operationTime = array())
    {
        $this
            ->setOperationTime($operationTime);
    }
    /**
     * Get OperationTime value
     * @return \StructType\JP_OperationTime[]|null
     */
    public function getOperationTime()
    {
        return $this->OperationTime;
    }
    /**
     * This method is responsible for validating the values passed to the setOperationTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOperationTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOperationTimeForArrayConstraintsFromSetOperationTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_OperationTimeOperationTimeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_OperationTimeOperationTimeItem instanceof \StructType\JP_OperationTime) {
                $invalidValues[] = is_object($arrayOfJP_OperationTimeOperationTimeItem) ? get_class($arrayOfJP_OperationTimeOperationTimeItem) : sprintf('%s(%s)', gettype($arrayOfJP_OperationTimeOperationTimeItem), var_export($arrayOfJP_OperationTimeOperationTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OperationTime property can only contain items of type \StructType\JP_OperationTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OperationTime[] $operationTime
     * @return \ArrayType\ArrayOfJP_OperationTime
     */
    public function setOperationTime(array $operationTime = array())
    {
        // validation for constraint: array
        if ('' !== ($operationTimeArrayErrorMessage = self::validateOperationTimeForArrayConstraintsFromSetOperationTime($operationTime))) {
            throw new \InvalidArgumentException($operationTimeArrayErrorMessage, __LINE__);
        }
        $this->OperationTime = $operationTime;
        return $this;
    }
    /**
     * Add item to OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OperationTime $item
     * @return \ArrayType\ArrayOfJP_OperationTime
     */
    public function addToOperationTime(\StructType\JP_OperationTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_OperationTime) {
            throw new \InvalidArgumentException(sprintf('The OperationTime property can only contain items of type \StructType\JP_OperationTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OperationTime[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_OperationTime|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_OperationTime|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_OperationTime|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_OperationTime|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_OperationTime|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OperationTime
     */
    public function getAttributeName()
    {
        return 'OperationTime';
    }
}
